:root {
  --sdhub-border-color: #000;
  --sdhub-box-shadow: 0 0 1px 1px var(--sdhub-border-color);
  --sdhub-box-shadow-radio-label: inset 0 0 5px 0 var(--sdhub-border-color);
  --sdhub-box-shadow-primary: inset 0 0 10px 1px var(--primary-400), 0 0 10px 1px var(--primary-400);
  --sdhub-secondary-button-background: var(--input-background-fill-hover);
  --sdhub-radio-input-not-checked: drop-shadow(0 0 2px var(--sdhub-border-color));
}

.dark {
  --sdhub-border-color: #303030;
  --sdhub-box-shadow: 0 0 1px 1px transparent;
  --sdhub-box-shadow-radio-label: none;
  --sdhub-secondary-button-background: var(--button-secondary-background-fill);
  --sdhub-radio-input-not-checked: drop-shadow(0 0 2px transparent);
}

#SDHub-Tab > .tab-nav {
  border: 0;
  margin: 8px 0 8px 0;
  gap: 15px;
}

#SDHub-Tab > .tab-nav > button {
  border: 1px solid transparent;
  border-radius: 100px;
  transition: .3s ease;
}

#SDHub-Tab > .tab-nav > button.selected {
  cursor: default;
  filter: drop-shadow(0 0 0 var(--primary-400));
  border-color: var(--primary-400);
  box-shadow: inset 0 0 10px 2px var(--primary-500), 0 0 5px 1px var(--primary-500);
  color: var(--sdhub-gallery-items-color);
}

#SDHub-Tab > .tab-nav > button:not(.selected):hover {
  color: var(--primary-500);
}

#SDHub-Tab .hide-this {
  visibility: hidden;
  pointer-events: none;
}

#SDHub-Tab .sdhub-row {
  gap: .5em;
}

#SDHub-Tab .sdhub-button-row-1 {
  flex-grow: 1;
}

#SDHub-Tab .sdhub-button-row-2 {
  flex-grow: 2;
}

#SDHub-Tab .sdhub-buttons {
  position: relative;
  height: 40px;
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
  align-items: center;
  justify-content: center;
  padding: 0;
  font-size: 17px;
  box-shadow: var(--sdhub-box-shadow);
}

#SDHub-Tab .sdhub-buttons:hover {
  filter: drop-shadow(0 0 5px var(--primary-500));
  box-shadow: var(--sdhub-box-shadow), 0 0 10px 1px var(--primary-500);
  color: var(--body-text-color-subdued);
  background: var(--button-primary-background-fill-hover);
}

#SDHub-Tab .sdhub-button-disabled {
  pointer-events: none;
  filter: brightness(0.6);
}

#SDHub-Downloader-Tab,
#SDHub-Uploader-Tab,
#SDHub-Archiver-Tab,
#SDHub-Shell-Tab {
  border: 0;
  margin: 0;
  padding: 10px 0px;
}

#SDHub-Texteditor-Tab {
  border: 0;
  margin: 0;
  padding: 10px 0px 0px;
}

#SDHub-Archiver-Radio-Row > .form {
  gap: 2rem;
}

#SDHub-Archiver-Radio-Format,
#SDHub-Archiver-Radio-Split {
  max-width: max-content;
}

#SDHub-Tab #SDHub-Downloader-Preview-Checkbox {
  justify-content: flex-start;
  width: max-content;
  margin: 5px 0 5px 10px;
}

#SDHub-Downloader-Scrape-Button,
#SDHub-Downloader-Txt-Button {
  display: flex;
  position: relative;
  height: 40px;
  white-space: nowrap;
  overflow: hidden;
  text-overflow: ellipsis;
  align-items: center;
  justify-content: center;
  padding: 0;
  font-size: clamp(15px, 4vw, 100%);
  transition: 0.4s ease;
  box-shadow: var(--sdhub-box-shadow);
  background: var(--sdhub-secondary-button-background);
}

#SDHub-Downloader-Scrape-Button {
  border-top-left-radius: var(--button-large-radius);
  border-bottom-left-radius: var(--button-large-radius);
}

#SDHub-Downloader-Txt-Button {
  border-top-right-radius: var(--button-large-radius);
  border-bottom-right-radius: var(--button-large-radius);
}

#SDHub-Downloader-Scrape-Button:hover,
#SDHub-Downloader-Txt-Button:hover {
  filter: drop-shadow(0 0 5px var(--primary-400));
  box-shadow: 0 0 10px 1px var(--primary-400);
  color: var(--primary-500);
}

#SDHub-Shell-Button:hover {
  filter: drop-shadow(0 0 5px var(--primary-500));
  box-shadow: 0 0 10px 1px var(--primary-500);
  color: var(--body-text-color-subdued);
  background: var(--button-primary-background-fill-hover);
}

#SDHub-Tab .sdhub-checkbox {
  display: flex;
  margin: 0;
  justify-content: flex-start;
  align-items: center;
  margin-left: 3rem;
}

#SDHub-Tab .sdhub-checkbox label {
  gap: 1rem;
}

#SDHub-Tab .sdhub-checkbox input {
  transform: rotate(45deg);
  border: 0;
  border-radius: 0;
  padding: 0;
  cursor: pointer;
  box-shadow: 0 0 3px 1px #000;
  transition: 0.4s ease;
}

#SDHub-Tab .sdhub-checkbox input:hover {
  filter: drop-shadow(0 0 10px var(--primary-400));
  box-shadow: 0 0 1px 2px var(--primary-500);
}

#SDHub-Tab .sdhub-checkbox input:checked {
  filter: drop-shadow(0 0 5px var(--primary-500));
  box-shadow: 0 0 20px 0px var(--primary-500);
  background-image: var(--radio-circle);
  background-color: var(--primary-500);
}

#SDHub-Tab .sdhub-checkbox span {
  margin: 0;
}

#SDHub-Tab .sdhub-input textarea,
#SDHub-Tab .sdhub-input input,
#SDHub-Tab .sdhub-radio input,
#SDHub-Tab .sdhub-output input,
#SDHub-Tab .sdhub-output textarea {
  box-shadow: var(--sdhub-box-shadow);
}

#SDHub-Tab .sdhub-radio label {
  box-shadow: var(--sdhub-box-shadow-radio-label);
}

#SDHub-Tab .sdhub-buttons,
#SDHub-Tab .sdhub-input textarea,
#SDHub-Tab .sdhub-input input,
#SDHub-Tab .sdhub-radio label,
#SDHub-Tab .sdhub-radio input,
#SDHub-Shell-Button {
  transition:
    box-shadow .4s ease,
    filter .4s ease,
    border-color .3s ease,
    background-color .3s ease,
    color .5s ease;
}

#SDHub-Tab .sdhub-input textarea:focus,
#SDHub-Tab .sdhub-input input:focus {
  box-shadow: 0 0 3px 1px var(--primary-400), inset 0 0 1px 1px var(--primary-400);
}

#SDHub-Tab .sdhub-input input:hover {
  filter: none !important;
}

#SDHub-Tab .sdhub-radio input:checked,
#SDHub-Tab .sdhub-radio input:checked:focus {
  border-color: var(--primary-500);
  filter: drop-shadow(0 0 5px var(--primary-500));
  box-shadow: 0 0 20px 0px var(--primary-500);
  background-image: var(--radio-circle);
  background-color: var(--primary-500);
}

#SDHub-Tab .sdhub-radio label:hover {
  box-shadow:
    inset 0 0 5px 1px var(--primary-400),
    inset 0 0 5px 1px var(--primary-400),
    inset 0 0 5px 1px var(--primary-400);
}

#SDHub-Tab .sdhub-radio input:checked + span {
  filter: drop-shadow(0 0 5px var(--primary-500));
}

#SDHub-Tab .sdhub-radio input:hover {
  cursor: pointer;
}

#SDHub-Tab .sdhub-radio input:not(:checked):hover {
  filter: var(--sdhub-radio-input-not-checked);
}

#SDHub-Tab .sdhub-radio input:not(:checked):hover {
  border-color: var(--primary-500);
  filter: drop-shadow(0 0 3px var(--primary-500));
  background-color: var(--checkbox-label-background-fill-hover);
}

.gradio-container-4-40-0 #SDHub-Downloader-Button-Row,
.gradio-container-4-40-0 #SDHub-Uploader-Button-Row,
.gradio-container-4-40-0 #SDHub-Uploader-Input {
  margin-top: -8px;
  gap: 8px;
}

.gradio-container-4-40-0 #SDHub-Tag-Dataframe table.table {
  overflow: hidden;
}

#SDHub-Uploader-Username-Box,
#SDHub-Uploader-Repo-Box {
  max-width: 240px;
}

#SDHub-Uploader-Branch-Box {
  max-width: min(160px, 100%);
}

#SDHub-Uploader-Radio-Box {
  max-width: max-content;
}

.gradio-container-4-40-0 #SDHub-Uploader-Radio-Box .svelte-1kzox3m,
:not(.gradio-container-4-40-0) #SDHub-Uploader-Radio-Box > div:nth-of-type(2) {
  margin-top: -3px !important;
}

#SDHub-Repo {
  margin-bottom: -2px;
  margin-top: 10px;
  text-align: center;
  font-size: 13px;
  font-weight: normal;
}

#SDHub-Repo > a {
  transition: 0.4s ease;
}

#SDHub-Repo > a:hover {
  color: var(--primary-400);
}

#SDHub-Tab .sdhub-tab-title {
  text-align: center;
  font-size: 20px;
  padding-bottom: 5px;
}

#SDHub-Tab .sdhub-tab-info {
  font-weight: normal;
  font-size: 13px;
  line-height: 1.8;
}

#SDHub-Tab .sdhub-tab-info.sdhub-archiver-tab-info {
  font-size: 14px;
  background: var(--input-background-fill);
  margin: 0;
  border-radius: var(--input-radius);
  padding: var(--input-padding);
}

#SDHub-Tab .sdhub-tab-info .sdhub-link,
#SDHub-Tab .sdhub-tab-info .sdhub-nonlink {
  padding-top: 2px;
  padding-bottom: 2px;
  padding-left: 5px;
  padding-right: 5px;
  border: 1px solid var(--color-accent);
  transition: 0.4s ease;
}

#SDHub-Tab .sdhub-tab-info .sdhub-link:hover {
  color: var(--color-accent);
  border: 1px solid orange;
}

#SDHub-Tab .sdhub-tab-info .sdhub-nonlink {
  pointer-events: none;
}

:not(.gradio-container-4-40-0) #SDHub-Tag-Dataframe,
:not(.gradio-container-4-40-0) #SDHub-Tag-Dataframe > div > div,
:not(.gradio-container-4-40-0) #SDHub-Tag-Dataframe table {
  overflow: visible !important;
}

#SDHub-Tab .sdhub-accordion {
  border: 1px solid var(--sdhub-border-color) !important;
  transition: .3s ease;
}

#SDHub-Tab .sdhub-accordion > .label-wrap {
  padding: 8px 0;
  margin: -8px 0;
}

#SDHub-Tab .sdhub-accordion > div[style*="display: block"] {
  margin-top: 8px;
}

#SDHub-Tab .sdhub-accordion:hover,
#SDHub-Tab .sdhub-accordion.sdhub-accordion-open {
  border-color: var(--primary-400) !important;
  box-shadow: var(--sdhub-box-shadow-primary);
}

#SDHub-Tag-Dataframe tbody {
  position: relative;
  z-index: 11;
}

#SDHub-Tag-Dataframe td {
  border: 0;
}

#SDHub-Tag-Dataframe td:hover {
  filter: drop-shadow(0 0 5px var(--primary-400));
  box-shadow: inset 0 0 0 1px var(--ring-color), 0 0 10px 1px var(--primary-400);
  color: var(--background-fill-primary);
  background: var(--button-primary-background-fill);
}

#SDHub-Tag-Dataframe table {
  border-collapse: separate;
  cursor: auto;
}

#SDHub-Tag-Dataframe thead {
  pointer-events: none;
}

#SDHub-Tag-Dataframe thead > tr {
  text-align: center;
}

#SDHub-Tag-Dataframe thead svg,
#SDHub-Tag-Dataframe td {
  pointer-events: auto;
}

#SDHub-Tag-Dataframe td.pulse-td {
  animation: pulse-td-box 2s alternate forwards;
}

@keyframes pulse-td-box {
  0% {
    filter: drop-shadow(0 0 5px var(--primary-400));
    box-shadow: inset 0 0 0 1px var(--ring-color), 0 0 10px 1px var(--primary-400);
    color: var(--background-fill-primary);
    background: var(--button-primary-background-fill);
  }
  33% {
    filter: drop-shadow(0 0 0 transparent);
    box-shadow: inset 0 0 0 1px var(--ring-color), 0 0 0 0 var(--primary-400);
    color: var(--body-text-color);
    background: transparent;
  }
  66% {
    filter: drop-shadow(0 0 5px var(--primary-400));
    box-shadow: inset 0 0 0 1px var(--ring-color), 0 0 10px 1px var(--primary-400);
    color: var(--background-fill-primary);
    background: var(--button-primary-background-fill);
  }
  100% {
    filter: drop-shadow(0 0 0 transparent);
    box-shadow: inset 0 0 0 1px var(--ring-color), 0 0 0 0 var(--primary-400);
    color: var(--body-text-color);
    background: transparent;
  }
}

#SDHub-Texteditor-Row {
  gap: inherit;
}

#SDHub-Texteditor-Input input {
  text-align: center;
  font-size: 15px;
  padding: 10px;
}

#SDHub-Texteditor-Info {
  padding-right: 2rem !important;
  z-index: 9999;
  top: 3.2rem;
  right: 0;
  position: absolute;
  pointer-events: none;
}

#SDHub-Texteditor-Info > .wrap {
  display: none;
}

#SDHub-Texteditor-Info input {
  border: 0;
  text-align: right;
  font-size: 17px;
  opacity: 0;
  transition: opacity 0.3s ease;
  background: transparent;
}

#SDHub-Texteditor-Editor {
  background: #1f1f1f;
  font-family: Consolas, 'Courier New', monospace;
  max-height: 1000px;
  overflow: auto !important;
}

#SDHub-Texteditor-Editor > div[data-testid="block-label"] {
  border: 1px solid #3a3a3a;
}

#SDHub-Texteditor-Editor .cm-content, #SDHub-Texteditor-Editor .cm-gutters {
  line-height: 1.4;
  font-size: 13px;
  font-family: Consolas, "Courier New", monospace;
}

#SDHub-Texteditor-Editor .cm-gutters {
  border-right: 1px solid #3a3a3a;
}

#SDHub-Texteditor-Editor span.\ͼ2c {
  color: #5e8a36;
  font-style: normal;
}

#SDHub-Texteditor-Editor span.\ͼ1q {
  color: #e89bdf;
}

#SDHub-Texteditor-Editor span.\ͼ1s {
  color: #31ffd5;
}

#SDHub-Texteditor-Editor span.\ͼ1t {
  color: #fffca4;
}

#SDHub-Texteditor-Editor span.\ͼ1x {
  color: #1c8fff;
}

#SDHub-Texteditor-Editor span.\ͼ1z {
  color: #fff;
}

#SDHub-Texteditor-Editor span.\ͼ21 {
  color: #fff;
}

#SDHub-Texteditor-Editor span.\ͼ23 {
  color: #cf6db9;
}

#SDHub-Shell-Button, #SDHub-Shell-Ghost-Button {
  border: 0;
  padding-bottom: 0;
  padding-top: 0;
  padding-left: 0.5rem;
  padding-right: 0;
  line-height: 0;
  flex-grow: 0.1;
  min-width: min(3rem, 100%);
  font-size: 40px;
  height: 3rem;
  border-radius: 50%;
  transition: 0.3s ease;
}
